package com.jpattern.gwt.client.view;

import com.google.gwt.user.client.ui.HasVisibility;
import com.google.gwt.user.client.ui.HasWidgets;
import com.jpattern.gwt.client.IApplicationProvider;
import com.jpattern.gwt.client.presenter.IPresenter;

/**
 * 
 * @author Francesco Cina'
 *
 * 14 Apr 2011
 */
public interface IView {

	void visit(IPresenter presenter);
	
	IPresenter getPresenter();
	
	void render(HasWidgets container);

	IErrorArea getErrorArea();
	
	void onNavigationEvent(String eventName);
	
	/**
	 * The widget will be hidden if the userSession doesn't belong to one of the roles allowedRoles 
	 * @param widget
	 * @param allowedRoles
	 */
	void hideIfUserNotInRole(HasVisibility widget, String[] allowedRoles);
	
	/**
	 * The widget will be hidden if the userSession is not valid 
	 * @param widget
	 */
	void hideIfUserValid(HasVisibility widget);

	void setApplicationProvider(IApplicationProvider provider);
}
